public class PileTableau implements IPile {

    protected int tailleMaximum;
    protected int taille;
    protected Object tab[];

	/**
	 * Default constructor
	 *
	 */
    public PileTableau( int tailleMaximum ) {

        this.tailleMaximum = tailleMaximum;
        taille = 0;
        tab = new Object [ tailleMaximum ];

    }


    public void empiler( Object o ) throws Exception {

        if (taille == tailleMaximum) {

            throw new Exception( "Pile pleine" );

        } else {

            tab[ taille ] = o;
            ++taille;

        }

    }

    public void depiler( ) throws Exception {

        if (taille == 0) {

            throw new Exception( "Pile vide" );

        } else {

            --taille;
            tab[ taille ] = null;

        }

    }

    public Object sommet( ) throws Exception {

        if (taille == 0) {

            throw new Exception( "Pile vide" );

        } else {

            return tab[ taille - 1 ];

        }

    }

    public boolean estVide( ) {

        return taille == 0;

    }


    public String toString() {
        String s = "";
        for (int i= 0; i < taille; ++i) {
            s += " " + tab[i].toString();
        }
        return s;
    }
}
